CreateChart proc
	LOCAL hObj:dword
	LOCAL w:dword
	LOCAL h:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	.if hDC==0
		invoke GetDC,hCHART
		mov hDC,eax
		invoke CreateCompatibleDC,hDC
		mov hCDC,eax
	.endif
	
	.if hDIB==0
		;Create buffer for loaded chart
		invoke CreateDIBSection,hCDC,pBMI,DIB_RGB_COLORS,0,0,0
		mov hDIB,eax
		invoke SelectObject,hCDC,hDIB
		mov hObj,eax
	.endif
	
	invoke StretchDIBits,hCDC,0,0,PixW,PixH,
			0,0,PixW,PixH,pPixelData,pBMI,DIB_RGB_COLORS,SRCCOPY
	invoke GdiFlush
		
	invoke DeleteObject,hObj
	
	pop edx
	pop edi
	pop esi
	
	ret

CreateChart endp

