StringToFloat proc pString:dword,pFloat:dword
	LOCAL buffer[256]:byte
	LOCAL result:real8
	LOCAL pBSTR:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx

	invoke lstrlen,pString
	mov ecx,eax
	invoke MultiByteToWideChar,CP_ACP,0,pString,ecx,addr buffer,sizeof buffer
	invoke SysAllocString,addr buffer
	mov pBSTR,eax
	invoke VarR8FromStr,pBSTR,800,LOCALE_NOUSEROVERRIDE,addr result
	invoke SysFreeString,pBSTR
	
	invoke RtlMoveMemory,pFloat,addr result,8
	
	pop edx
	pop edi
	pop esi
	
	ret

StringToFloat endp

MapAFile proc pFileName:dword,pMappedFile:dword,pFileSize:dword
	LOCAL hFileRead:dword
	LOCAL hMapFile:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	invoke CreateFile,pFileName,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
	.if eax==INVALID_HANDLE_VALUE
		invoke MessageBox,0,ASTR("File not registred!"),0,MB_OK or MB_ICONERROR
		mov eax,-1
		jmp @Exit
	.endif
	mov hFileRead,eax
	mov edi,pFileSize
	mov eax,dword ptr [edi]
	.if eax==-1 || eax==0
		invoke GetFileSize,hFileRead,0
		mov dword ptr [edi],eax
	.endif
	
	invoke CreateFileMapping,hFileRead,0,PAGE_READONLY,0,eax,0
	.if eax==0
		invoke MessageBox,0,ASTR("File not mapped!"),0,MB_OK or MB_ICONERROR
		mov eax,-1
		jmp @Exit
	.endif
	mov hMapFile,eax
	
	invoke MapViewOfFile,hMapFile,FILE_MAP_READ,0,0,0
	.if eax==0
		invoke MessageBox,0,ASTR("View of file did not succeed!"),0,MB_OK or MB_ICONERROR
		mov eax,-1
		jmp @Exit
	.endif
	mov edi,pMappedFile
	mov dword ptr [edi],eax
	
	
	invoke CloseHandle,hMapFile
	invoke CloseHandle,hFileRead
	
@Exit:
	pop edx
	pop edi
	pop esi

	ret

MapAFile endp

