include windows.inc
include kernel32.inc
include user32.inc
include Comctl32.inc
include shell32.inc
include gdi32.inc
include shlwapi.inc
include msvcrt.inc
include comdlg32.inc
include oleaut32.inc
include version.inc
include advapi32.inc

includelib kernel32.lib
includelib user32.lib
includelib Comctl32.lib
includelib shell32.lib
includelib gdi32.lib
includelib shlwapi.lib
includelib msvcrt.lib
includelib comdlg32.lib
includelib oleaut32.lib
includelib version.lib
includelib advapi32.lib

include StringFunctions.Inc
includelib StringFunctions.lib


bsbChart4				PROTO
bsbHeader4				PROTO
ChartProc				PROTO	:DWORD,:DWORD,:DWORD,:DWORD
ComputeChartFile		PROTO
CreateChart				PROTO
GetRowPixels4			PROTO	:dword,:dword,:dword,:dword,:dword
MainDlgProc				PROTO	:HWND,:UINT,:WPARAM,:LPARAM
MapAFile				PROTO	:dword,:dword,:dword
StringToFloat			PROTO	:dword,:dword
SetWindowCaption		PROTO
bsbMemory				PROTO
AllocatePixelMemory		PROTO

ASTR macro args:VARARG
	LOCAL sym
	data segment
		ifidni <args>,<>
			sym db 0
		else
			sym db args,0
		endif
	data ends
	exitm <offset sym>
endm

include Struct.inc

.const
include Constants.inc

.data
mul_mask						db 8 DUP(0,63,31,15,7,3,1,0)
szFilterKAP						db "Charts(*.kap)",0,"*.kap",0,0
zoomFactor						real8 1.0f
szAppName						db "Navigation application 3a",0

.data?
hInstance						dd ?
hMain							dd ?
hCHART							dd ?
hDC								dd ?
hCDC							dd ?
hHeap							dd ?
OldChartProc					dd ?
szFileName						db 256 dup (?)
x								dd ?
y								dd ?
hFrame							dd ?
imageH							dd ?
imageW							dd ?
padding							dd ?
zoom							dd ?
mapview							dd ?
xPos							dd ?
yPos							dd ?
bsbH							dd ?
bsbW							dd ?
ColorDepth						dd ?
LatShift						real8 ?
LongShift						real8 ?
pBMI							dd ? ;pointer to bitmapinfoheader
pPixelData						dd ? ;pointer to pixel data
memorysize						dd ? ;size of pixel data memory
pMemory							dd ? ;pointer to mapped bsb chart file
filesize						dd ? ;size of mapped bsb chart file
pREF							dd ? ;pointer to chart reference points table
pPLY							dd ? ;pointer to chart boundery points table
pCHARTDATA						dd ? ;pointer to registred chart data
hDIB							dd ?
pFirstItemJmpTable				dd ? ;pointer to first item in bcb chart jump table



FrameRectangle					RECT <>
ColStart						dd ?
ColEnd							dd ?
RowStart						dd ?
RowEnd							dd ?
PixW							dd ?
PixH							dd ?